(script-fu-register
    "script-fu-export-android-drawable"         ;func name
    "Export Drawables"                          ;menu label
    "Exports the current image scaled for different\
      screen densities (MDPI, HDPI, XHDPI, XXHDPI)\
      into corresponding folders (drawable-mdpi,\
      drawable-hdpi, drawable-xhdpi, drawable-xxhdpi).\
      The folders must be created first in the root folder.\
      The saved filename is taken from the image,\
      so the image should be saved first."      ;description
    "arkaran"                                   ;author
    "arkaran, 2015"                             ;copyright notice
    "2015-01-29"                                ;date created
    ""                     ;image type that the script works on
    SF-IMAGE        "Input image"   0
    SF-DIRNAME      "Root folder"   "/home/user/Projects/android/Icons"
    SF-ADJUSTMENT   "Width (MDPI)"  '(48 1 10000 1 10 0 1)
    SF-ADJUSTMENT   "Height (MDPI)" '(48 1 10000 1 10 0 1)
)
(script-fu-menu-register "script-fu-export-android-drawable" "<Image>/File/Export For Android")
(define (script-fu-export-android-drawable image folder width height)
    (let*
        (
            (image1 (car (gimp-image-duplicate image)))
            (image2 (car (gimp-image-duplicate image)))
            (image3 (car (gimp-image-duplicate image)))
            (image4 (car (gimp-image-duplicate image)))
            (width1 width)
            (height1 height)
            (width2 (* width 1.5))
            (height2 (* height 1.5))
            (width3 (* width 2))
            (height3 (* height 2))
            (width4 (* width 3))
            (height4 (* height 3))
            (filename (car (gimp-image-get-name image)))
            ; replace extension for png image
            (len (string-length filename))
            (basename (substring filename 0 (- len 4)))
            (filename2 (string-append basename ".png"))
            (path1 (string-append folder "/drawable-mdpi/" filename2))
            (path2 (string-append folder "/drawable-hdpi/" filename2))
            (path3 (string-append folder "/drawable-xhdpi/" filename2))
            (path4 (string-append folder "/drawable-xxhdpi/" filename2))
        )
        
        (gimp-image-scale image1 width1 height1)
        (gimp-image-merge-visible-layers image1 1)
        (file-png-save-defaults 1 image1 (car (gimp-image-get-active-drawable image1)) path1 filename2)
        (gimp-image-delete image1)
        
        (gimp-image-scale image2 width2 height2)
        (gimp-image-merge-visible-layers image2 1)
        (file-png-save-defaults 1 image2 (car (gimp-image-get-active-drawable image2)) path2 filename2)
        (gimp-image-delete image2)
        
        (gimp-image-scale image3 width3 height3)
        (gimp-image-merge-visible-layers image3 1)
        (file-png-save-defaults 1 image3 (car (gimp-image-get-active-drawable image3)) path3 filename2)
        (gimp-image-delete image3)
        
        (gimp-image-scale image4 width4 height4)
        (gimp-image-merge-visible-layers image4 1)
        (file-png-save-defaults 1 image4 (car (gimp-image-get-active-drawable image4)) path4 filename2)
        (gimp-image-delete image4)
    )
)
