; filltrans.scm
; by Rob Antonishen
; http://ffaat.pointclark.net


(define (filltrans img inLayer inStep inTransfer)
  (let*
    ( 
      (inStep (/ inStep 2))
      (blurLayer (car (gimp-layer-copy inLayer TRUE)))
      (alphaVal 0)
      (blursize inStep)
      (alphasel 0)
    )
    ;  it begins here
    (gimp-context-push)
	(gimp-image-undo-group-start img)
	(gimp-progress-init "Flooding out Colour" -1)
    
    (gimp-selection-layer-alpha inLayer)
    (set! alphasel (car (gimp-selection-save img)))
    (gimp-selection-none img)
    
    (gimp-image-add-layer img blurLayer (+ (car (gimp-image-get-layer-position img inLayer)) 1))

    (plug-in-threshold-alpha RUN-NONINTERACTIVE img inLayer 254)
    (plug-in-threshold-alpha RUN-NONINTERACTIVE img blurLayer 254)
    
    (while (< alphaVal 1)
      (gimp-selection-layer-alpha blurLayer)
      (gimp-selection-border img blursize)
      (gimp-selection-sharpen img)
      (if (equal? (car (gimp-selection-is-empty img)) FALSE)
        (plug-in-gauss RUN-NONINTERACTIVE img blurLayer blursize blursize 0)  
      )
      (gimp-levels blurLayer HISTOGRAM-ALPHA 0 128 1 0 255)
      (gimp-displays-flush)     
      (gimp-selection-none img)
      (set! alphaVal (list-ref (gimp-histogram blurLayer HISTOGRAM-ALPHA 255 255) 5))
      (gimp-progress-update alphaVal)
      (set! blursize (+ blursize inStep))
    )
    
    (gimp-selection-layer-alpha inLayer)
    (gimp-selection-invert img)
    
    (plug-in-gauss RUN-NONINTERACTIVE img blurLayer (* inStep 2) (* inStep 2) 0)   
    
    (gimp-image-remove-layer img inLayer)
    
    (when (equal? inTransfer TRUE)
      (gimp-selection-load alphasel)
      (gimp-layer-add-mask blurLayer (car (gimp-layer-create-mask blurLayer ADD-SELECTION-MASK)))
      (gimp-image-remove-channel img alphasel)
    )
      
    (gimp-selection-none img)
    (gimp-displays-flush)      
    
	(gimp-image-undo-group-end img)	
	(gimp-context-pop)
  )
)

(script-fu-register "filltrans"
        		    "<Image>/Layer/Transparency/Flood Fill Transparency..."
                    "Flood out colours until there is no transparency."
                    "Rob Antonishen"
                    "Rob Antonishen"
                    "Aug 2011"
                    "RGB* GRAY*"
                    SF-IMAGE      "image"      0
                    SF-DRAWABLE   "drawable"   0
					SF-ADJUSTMENT "Start and Step Size" (list 1 1 20 1 5 0 SF-SLIDER)
                    SF-TOGGLE     "Transfer alpha to layer mask" TRUE
)